// -----------------------------------------------------------------------------------------

library Blank;         // Rename this, it becomes the name of the DLL

uses
  Windows,
  Unit1 in 'Unit1.pas' {Form1};

{$E dll}               // To tell the compiler to make a DLL not an EXE

// -----------------------------------------------------------------------------------------

Const
  Plugin_Name = 'Un-named'; // The name that shows-up in PEiD's list of plugins

// -----------------------------------------------------------------------------------------

Type
  DLL_RET_MSG = Record
    szMsgText : PChar;
    szMsgHead : PChar;
    dRetVal   : DWORD;
    dRetExVal : DWORD;
    dFlags    : DWORD;
  End;

// -----------------------------------------------------------------------------------------
// The main procedure..  If you don't want a form, remove it here and replace
//  with your code (and remove unit1 above)

function RunPlugin(hMainDlg: HWND; szFname: PChar) : String;
begin

    // pass filename to plugin
    // pass hwnd of PEiD, or PE-Tools, if useful to you

    Target_Filename := szFname;
    Caller_Handle := hMainDlg;


    // Put your code here, and in Form1.create as usual


    Form1 := TForm1.Create(Nil);
    Try
      Form1.ShowModal
    Finally
      Form1.Free;
    End;

    result:='Done :)';  // displayed in PEiD message, where it would say packer name

end;

// -----------------------------------------------------------------------------------------

function DoMyJob(hMainDlg: HWND; szFname: PChar; lpReserved: DWORD; DRM: DLL_RET_MSG):DWORD; cdecl;
var
  S : String;
begin
 Result:=1;

 Try
  ShowWindow(hMainDlg,SW_HIDE);         // Hides PEiD, in case it's set to be always on top

  S := RunPlugin(hMainDlg,szFname);     // call main routine, with filename

  IF S <> '' THEN
   SetDlgItemText(hMainDlg,$03E9,PChar(S));   // write into PEiD message box :)

  Finally
    ShowWindow(hMainDlg,SW_SHOW);        // show PEiD again
  End;
end;

// -----------------------------------------------------------------------------------------

function StartPTPlugin(hDlg:HWND):DWord;stdcall;
var
  S : String;
begin
 S := RunPlugin(hDlg,'');             // Call main procedure, from PE-Tools
                                      // Note PE-Tools doesn't give you a filename,
                                      // so a open dialog or something must be used to get a file.
 IF S <> '' THEN
   SetDlgItemText(hDlg,$9900,PChar(S));  // Write to PE-Tools message box :)

 Result:=0;
end;

// -----------------------------------------------------------------------------------------

function LoadDll:PChar;cdecl;
begin
  result := Plugin_Name;                   // Called by PEiD to get the plugins name
end;

// -----------------------------------------------------------------------------------------

function GetPTPluginName:PChar;stdcall;
begin
  Result := Plugin_Name;                   // same, but for PE-Tools
end;

// -----------------------------------------------------------------------------------------

exports
    DoMyJob,                              // Called by PEiD to do plugins work
    LoadDll,                              // Called by PEiD to get plugins name
    GetPTPluginName,                      // Called by PE-Tools to get plugins name
    StartPTPlugin;                        // called by PE-Tools to do plugins work

// -----------------------------------------------------------------------------------------

begin
end.

// -----------------------------------------------------------------------------------------

